###### R potet (prce s "tabulkami")######

setwd("C:/Users/Navratil/Documents/R")
# setwd("C:/Users/uivatel/Documents/R") # cesta pro koln PC

####Matice####
# Vytvom si vektor c1 z pedchoz lekce

c1 <- c(50, 14, 57, 145, 79, 9, 357, 63, 48, 10, 83, 40, 10, 10, 18, 61, 19, 38, 98, 93, 44)
c1

# UPOZORNN - matice me mt vektory jen jednoho typu, proto si vytvome 
# dal seln vektor - c4

c4 <- c(80, 102, 142, 92, 102, 72, 363, 51, 102, 113, 159, 127, 163, 60, 63, 99, 208, 549, 151, 144, 65)
c4

# Matici (pokud ji neimportujeme), nejastji tvome spojenm vektor funkc cbind, 
# kter tvo matici po sloupcch (po dcch je to funkce rbind)

mat1 <- cbind(c1,c4)
mat1
class(mat1)

# Matici mu snadno transponovat (otoit) funkc t

mat1_t <- t(mat1)
mat1_t
rm(mat1_t)

# Hodnoty v matici vybrm analogicky vektorm.
# dek je na prvn pozici a sloupec na druh,
# tj. [3,2] mi vybere slo na tetm dku a v prvnm sloupci

mat1[3,2]

# [1,] mi vybere prvn dek a vechny sloupce a [,2] mi vybere druh sloupec 
# a vechny dky:

mat1[1, ]
mat1[ ,2]


# Matici mohu vytvoit  i jako przdnou funkc matrix()

mat2 <- matrix(data = NA, nrow = 21, ncol = 2)
mat2

# . . . a nsledn ji "nakrmit" sly z vektrortakto naplnm matici sly z vektor:

mat2[,1] <- c1
mat2[,2] <- c4
mat2

# Sloupce matice si pro pehlednost mu pojmenovat funkc colnames()

colnames(mat2) <- c("jaro","podzim")
mat2 #podvejme se na ni

# Analogicky lze pojmenovat dky matice funkc rownames(),
# a to bu run, jak jsme si to ukzali v ppad colnames nebo pomoc 
# dat z vektoru, zde si zalome vektor plocha

plocha <- c("1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21")
rownames(mat2) <- plocha
mat2 #podvejme se na ni


####Pole####
# pole je vcerozmrn matice a tvo se pomoc funkce array() - my ji 
# v zkladnm kurzu pouvat nebudeme

####Datov tabulka####
# Datovou tabulku (data frame) budete hodnotit astji ne matici, protoe 
# budete mt k dispozici asto seln i textov daje.
# Prce je analogick maticm
# pro prci ale nejprve vytvome faktor s vegetanm typem:

veg <- c("typ3", "typ2", "typ3", "typ2", "typ2", "typ2", "typ1", "typ3", "typ2", "typ2", "typ3", "typ3", "typ2", "typ2", "typ1", "typ2", "typ2", "typ2", "typ3", "typ1", "typ3")
veg

# Nejastji budete tvoit datovou tabulku spojenm vektor funkc data.frame,
# vytvome si tabulku, kde bude slo plochy, vegetan typ a jarn a podzimn men:

dat_tab1 <- data.frame(plocha,veg,c1,c4)
dat_tab1 #podvme se na ni
colnames(dat_tab1) <- c("plocha","vegetacni_typ", "jaro", "podzim")
dat_tab1 #podvme se na ni
rownames(dat_tab1) <- plocha
dat_tab1 #podvme se na ni

# Jak piadit nov sloupec je mono nkolika zpsoby, shrnuty jsou zde:
# http://portal.matematickabiologie.cz/index.php?pg=zaklady-informatiky-pro-biology--vypocetni-matematicke-systemy--vyuka-jazyka-r--datove-tabulky-a-seznamy--funkce-pro-manipulaci-s-datovymi-tabulkami-a-seznamy
# nejastji asi pouijete nsledujc formuli, j nakonec piadme sloupec za letn men:

dat_tab1$leto <- c(94, 64, 63, 124, 76, 65, 325, 20, 26, 69, 118, 85, 40, 90, 38, 77, 69, 80, 96, 129, 60)
dat_tab1 #podvme se na ni

# Tm jsme vyeili pilepen sloupce, co kdy ale potebuji propojit tabulky pes relaci, tedy analogii
# funkce SVYHLEDAT z MS Excel?
# Spojen tabulek se e rzn, efektivn monost je pouit funkce merge().
# Pklad: 2 lokality, na kad 3 plochy. V kad jsem zaznamenal vskyt Drosera 
# rotundifolia. Mm tabulku ploch s vskytem D.r. a tabulku pazen ploch 
# k lokalit a informaci o managementu. 
# Chci piadit k rostlinm management lokalit a nedlat to run.
# nejpve vytvom ob datov tabulky a nsledn se je pokusm spojit

plot_data <- data.frame(plot = c(2, 4, 6, 1, 3, 5), drosera = c("Y", "N", "N", "Y","Y","Y"))
plot_data #podvme se na ni

locality_data <- data.frame(plot = c(1, 2, 3, 4, 5, 6), locality = c(rep("loc1", 3), rep("loc2", 3)), management = c(rep("koseno",3), rep("nekoseno",3)))
locality_data #podvme se na ni

# ... no a konen zadm funkci merge(), kterou ob tabulky propojm (pes promnnou plot - k tomu slou
# atribut by) a vsledek bude uloen v objektu s nzvem sum:

sum <- merge(x = plot_data, y = locality_data, by = "plot", all = TRUE)
sum

# vce naleznete zde: http://portal.matematickabiologie.cz/index.php?pg=zaklady-informatiky-pro-biology--analyza-dat-v-r--uprava-a-transformace-dat-v-r--spojovani-datovych-tabulek

# Na rozdl od matice sloupec v data.frame mu zvolit pomoc symbolu $.
# Zrove si vimnte, e vegetan typ je faktor - protoe textov etzec 
# datov tabulka povauje automaticky za faktor (= m identitifikovan Levels):

dat_tab1$vegetacni_typ
is.factor(dat_tab1$vegetacni_typ)

# Pokud chci vytvoit kategoriln promnnou z selnho etzce, tak 
# to musm udlat pomoc funkce as.factor().
# Napklad pro plocha by syntaxe vypala takto
dat_tab1$plocha <- as.factor(dat_tab1$plocha)
# dlat to ale nebudeme, protoe plocha u faktor je

is.factor(dat_tab1$plocha) #testujeme, jestli je sloupec plocha opravdu faktor

# Sumrn data datov tabulky volme funkc summary()

summary(dat_tab1)

# Datov tabulka se ale d vytvoit i jednoduchou konverz matice

dat_tab2 <- as.data.frame(mat2)
class(dat_tab2) #podvme se na typ

# Funguje to pekvapiv i obrcen, tj. z datov tabulky na matrix (matici) 

mat3 <- as.matrix(dat_tab1)
class(mat3) #podvme se na typ

# nicmn s hledem na chakter matice jsou vechny daje textov

mat3 #podvme se na daje

# Selekce jednotlivch hodnot v datov tabulce, ale i v matici, mu provst 
# na zklad definovanch podmnek

vyber1 <- dat_tab1[dat_tab1$jaro>60,] 
vyber1 #podvme se na nj
vyber2 <- dat_tab1[dat_tab1$podzim<100,]
vyber2 #podvme se na nj

# . . . a te to meme spojit - "and" se dl pomoc &

vyber3 <- dat_tab1[dat_tab1$jaro>60 & dat_tab1$podzim<100,]
vyber3  #podvme se na nj

# pokud potebujete vybrat pmo hodnotu, muste dt dvojit rovntko ==

vyber4 <- dat_tab1[dat_tab1$jaro==10,] 
vyber4  #podvme se na nj

# mno a pokud chcete vbr bez konkrtnch hodnot tak je teba zadat != 
vyber5 <- dat_tab1[dat_tab1$jaro!=10,] 
vyber5 #podvme se na nj

# Hodnoty si mu i uspodat - pokud s nimi chci dle nco dlat, 
# tak pomoc ipeky uloit jako novou datovou tabulku

sort(dat_tab1$jaro)



####Seznamy####
# Vektory, matice i datov tabulky mohu skldat do seznam pomoc funkce list
# definuji seznam

sez1 <- list()

# Do listu narvu ti matice - pomoc dvojit hranat zvorky

sez1[[1]] <- mat1
sez1[[2]] <- mat2
sez1[[3]] <- mat3
sez1 #prohldnu si ji
class(sez1) #zkontroluji typ

# Vbry jsou analogick vbrm z vektor a matic,
# pklad vybere z tabulky 2, sloupec 2, dky 1-10

sez1[[2]][1:10,2]

# Jednotliv objekty v listu mu pojmenovat:

names(sez1) <- c("tabulka1", "tabulka2", "tabulka3")
sez1 #zkontroluji vsledek


# Podle jmen mu pomoc symbolu $ vybrat hodnoty

sez1$tabulka2[1:10,2]

# Na vbr mu aplikovat funkce, zde prmr z pedchozho vbru

mean(sez1$tabulka2[1:10,2])

# Do seznam mu poskldat vechny typy objekt (a to vetn seznam) 
# a vytvoit v nm sloitou strukturu seznam v seznamech

sez2 <- list()
sez2[[1]] <- sez1
sez2[[2]] <- dat_tab1
names(sez2) <- c("seznam1","datova_tabulka1")
sez2 #podvejme se na ni

# Statistick funkce maj komplikovan seznamy jako vstupy, proto je teba 
# bt schopen se v nich orientovat

sez2$seznam1$tabulka2[,2] #dotaz na matici
sez2$datova_tabulka1$jaro #dotaz na datovou tabulku